<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { getPageMetadata } from '~/common/meta';
import { CONTENT_TYPES } from '~/common/content-types';
import { getClient } from '~/plugins/contentful';
import { LivePreviewMixin } from '~/mixins';
import { ContentfulLivePreview } from '@contentful/live-preview';
import { convertToCaseSensitiveLocale } from '~/common/util';
import { assemblePageContent } from '~/services/free-trial/devsecops.service';
import { NextStepAlt } from '~/components/common/index.vue';

import {
  FreeTrialAccolades as Accolades,
  FreeTrialRecognitionCards,
  FreeTrialHero as Hero,
  FreeTrialSquares as Squares,
} from '~/components/free-trial/index.vue';

export default Vue.extend({
  name: 'FreeTrial',
  components: {
    Hero,
    Accolades,
    Squares,
    FreeTrialRecognitionCards,
    NextStepAlt,
  },
  mixins: [LivePreviewMixin],
  layout: 'free-trial-navigation',
  async asyncData({ i18n }: any) {
    try {
      const response = await getClient().getEntries({
        content_type: CONTENT_TYPES.PAGE,
        'fields.slug': 'free-trial/devsecops',
        include: 10,
        locale: convertToCaseSensitiveLocale(i18n.locale),
      });

      const { pageContent } = response.items[0].fields;

      const data = assemblePageContent(pageContent);
      const metadata = response.items[0].fields.seoMetadata[0].fields;
      return { data, metadata };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) =>
          (this.data = assemblePageContent(updatedData)),
      });
      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <div>
    <component
      :is="component.name"
      v-for="component in data.components"
      :key="component.name"
      :data="component.data"
    />
    <NextStepAlt disable-secondary-button />
  </div>
</template>
